#ifndef DM_INTERFACES_H
#define DM_INTERFACES_H

#include "XCommon.h"

class UI_Manager
{
public:
	virtual void ShowNextButton(bool doShow)					= 0;
	virtual void ShowPreviousButton(bool doShow)				= 0;
	virtual void ShowProgressBar(bool doShow)					= 0;
	virtual void ShowInputText( bool doShow )					= 0;
	virtual void ShowMultiButton(bool doShow)					= 0;
	virtual void IdleProgressBar(long curPos)					= 0;
	virtual void SetProgressBarMax(long maxPos)					= 0;
	virtual void InvalidateDialog(void)							= 0;
	virtual void SetNextButtonTitle(const char *pNewTitle)		= 0;	
	virtual void SetPreviousButtonTitle(const char *pNewTitle)  = 0;
	virtual void SetMultiButtonTitle(const  char *pNewTitle)	= 0;
	virtual void SetMessage(const char *pNewTitle, bool doInval = false)				= 0;
	virtual void SetInputMessage( const char* pNewMessage)		= 0;
	virtual void MessageBox(const char *pNewTitle)				= 0;
	virtual void Exit(void)										= 0;
	virtual int OpenDownloadFileDialog(void)					= 0;
	virtual int OpenOSFile(void)								= 0;
	virtual void LockExitMenu(bool doLock)						= 0;
};


class IStateManager
{
public:
	virtual void MultiPressed()		= 0;
	virtual void NextPressed()		= 0;
	virtual void PreviousPressed()  = 0;
	virtual bool UpdatePage()		= 0;
};


UI_Manager &GetUIManager();
IStateManager &GetStateManager();

class XFileString
{
public:
	XFileString()
	{
		myLen		= 0;
		myBuffer	= 0;
	}
	virtual ~XFileString()
	{
		if(myBuffer)
			delete [] myBuffer;
	}
	long	GetLength() { return myLen;}
	char *	GetBuffer() { return myBuffer;}
	uchar	GetChar(ulong index) { if(index >= myLen) return 0; return myBuffer[index];}
	bool	LoadFile(const char *pPath);
private:
	long myLen;
	char *myBuffer;
};


#endif //DM_INTERFACES_H
